import { F as FetchOptions, U as UseFetchResult } from '../fetch-fEi2WVOX.js';

/**
 * Custom hook for fetching data using either GET or non-GET methods (POST, PUT, DELETE etc.)
 * @param {string} url - The URL you want to fetch data from.
 * @param {FetchOptions} options - Options for configuring the fetch request.
 * @returns {UseFetchResult<T>} - Returns the result object.
 */
declare const useFetch: <T>(url: string, options?: FetchOptions) => UseFetchResult<T>;

export { useFetch };
