#!/usr/bin/env node
import { outro, note, group, confirm, text, select, cancel } from '@clack/prompts';
import { FileUtils } from '@code-shaper/shaper-utils';
import { getDestinationDirectories, isEmptyDir, copyTemplates, replaceStringInFiles } from '@npm-smith/utils/file';
import { install } from '@npm-smith/utils/install';
import { isPotentiallyStandalone, constructRootPackageName, sortPackageJson, handleWorkspaces, identifyPackageManager } from '@npm-smith/utils/packages';
import * as n from 'node-emoji';
import p from 'path';
import i from 'picocolors';
import { fileURLToPath } from 'url';
import a from 'shell-artist';

function c(e,o){let t=/^@[a-z0-9-_]+$/,r=/^(?!.*\..\.)[a-z0-9_.-]+$/;if(e==="scope"){if(o.startsWith("@")||(o="@"+o),!t.test(o))return "Invalid scope format. Scope must be lowercase letters, numbers, '-', or '_'."}else if(e==="packageName"&&!r.test(o))return "Invalid package name format. Package name must be lowercase, can include '-', '_', or '.', but not start or end with '.', or contain '..'"}var m=getDestinationDirectories(void 0,void 0,"single"),l=m.map(e=>({value:e,label:e,hint:""})),d=[{value:"yarn",label:"yarn",hint:"recommended"},{value:"npm",label:"npm",hint:""},{value:"pnpm",label:"pnpm",hint:"recommended"}];var x=fileURLToPath(import.meta.url),j=p.dirname(x),f=p.join(process.cwd(),"package.json"),u=p.join(j,"..","template");var C=isPotentiallyStandalone();async function O(){return await group({isScoped:async()=>await confirm({message:"Is this going to be a scoped package? (visit https://docs.npmjs.com/cli/v10/using-npm/scope for more info)",initialValue:!0}),scopeName:async({results:e})=>e.isScoped?await text({message:"What is going to be your organization/scope name?",initialValue:"my-org",validate:o=>c("scope",o)}):"",packageName:async()=>await text({message:"What is going to be your package name?",initialValue:"react-hooks",validate:e=>c("packageName",e)}),destination:async()=>!C&&m.length?await select({message:"Where do you want to create the new package?",options:l}):"",pkgManager:async()=>identifyPackageManager()??await select({message:"Choose your favorite package manager",options:d})},{onCancel:()=>{cancel(i.red(`${n.get("no_entry")} Operation cancelled`)),process.exit(0);}})}var G={blue:"#add7ff",cyan:"#89ddff",green:"#5de4c7",magenta:"#fae4fc",red:"#d0679d",yellow:"#fffac2"},h=async()=>{let e=a.createAscii("React Hooks"),o=a.applyGradient(e,Object.values(G)),t=identifyPackageManager();(t==="yarn"||t==="pnpm")&&console.log(""),a.log(o,{box:{title:"Welcome to",dimBorder:!0,padding:2,borderColor:"cyan"}}),a.log("",{emoji:"wave",center:!0});};async function L(){isEmptyDir()&&(outro(i.red(`${n.get("no_entry")} This directory is empty. Create an app and try again...`)),process.exit(1)),FileUtils.fileExists(f)||(outro(i.red(`${n.get("no_entry")} No package.json found!`)),process.exit(1)),h(),note("You have triggered the executable i.e. a package with sample custom hooks will be created in your project",i.blue("INFO"));let e=await O(),{isScoped:o,packageName:t,scopeName:r,destination:T,pkgManager:w}=e,s=p.join(process.cwd(),T,t);copyTemplates(u,s,["__template__"]),replaceStringInFiles(s,"{{rootPackageName}}",constructRootPackageName(t,o,r)),sortPackageJson(p.join(s,"package.json")),await handleWorkspaces(),await install(w,process.cwd()),outro(i.green(`${n.get("partying")} You're all set!`));}L().catch(console.error);
