import { I as IRef } from '../intersection-DjTcXkeq.js';

interface IRect {
    width: number;
    height: number;
    top: number;
    bottom: number;
    left: number;
    right: number;
}
type IResizeHandler = (rect: IRect) => void;
type RoundingFn = "round" | "ceil" | "floor" | "trunc";
interface IUseResizeObserverBaseOptions {
    onResize?: IResizeHandler;
    round?: RoundingFn;
}
interface IUseResizeObserverOptionsWithToFixed {
    onResize?: IResizeHandler;
    round: "toFixed";
    toFixedDigits: number;
}

declare function useResizeObserver(ref: IRef, options: IUseResizeObserverBaseOptions & {
    onResize: IResizeHandler;
}): void;
declare function useResizeObserver(ref: IRef, options: IUseResizeObserverBaseOptions): IRect | null;
declare function useResizeObserver(ref: IRef, options: IUseResizeObserverOptionsWithToFixed): IRect | null;

export { useResizeObserver };
